'use strict';

exports.__esModule = true;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('./_');

var isSchema = _require.isSchema;

var Lazy = function () {
  function Lazy(mapFn) {
    _classCallCheck(this, Lazy);

    this.resolve = function (value) {
      var schema = mapFn(value);
      if (!isSchema(schema)) throw new TypeError('lazy() functions must return a valid schema');

      return schema;
    };
  }

  Lazy.prototype.cast = function cast(value, options) {
    return this.resolve(value).cast(value, options);
  };

  Lazy.prototype.validate = function validate(value, options) {
    return this.resolve(value).validate(value, options);
  };

  return Lazy;
}();

exports.default = Lazy;
module.exports = exports['default'];